package pwc.taxtech.atms.controller;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.dto.CellTemplateConfigDto;
import pwc.taxtech.atms.service.CellTemplateService;

import java.util.Collections;
import java.util.List;

@RestController
@RequestMapping(value = "api/v1/celltemplate")
public class CellTemplateController {
    private static final Logger logger = LoggerFactory.getLogger(AccountController.class);
    @Autowired
    CellTemplateService cellTemplateService;

    @RequestMapping(value = "configList/{templateID}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody
    List<CellTemplateConfigDto> GetConfigList(@PathVariable String templateID) {
        if(StringUtils.isEmpty(templateID)){
            return Collections.emptyList();
        }

        try {
            return cellTemplateService.GetCellConfigList(templateID);
        } catch (Exception e) {
            logger.error("GetCellConfigList",e);
        }

        return Collections.emptyList();
    }
}
