package pwc.taxtech.atms.controller;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.dto.TemplateDto;
import pwc.taxtech.atms.service.TemplateService;

import java.util.Collections;
import java.util.List;

@RestController
@RequestMapping(value = "api/v1/template")
public class TemplateController {
    private static final Logger logger = LoggerFactory.getLogger(AccountController.class);

    @Autowired
    TemplateService templateService;
//todo:
//[Route("getTemplateJson")]
//    [HttpGet]
//    public IHttpActionResult GetTemplateJson(string templateID)
//    {
//        return this.Ok(templateService.GetTemplateJson(templateID));
//    }

    @RequestMapping(value = "get", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody
    List<TemplateDto> get(@RequestParam String templateGroupID, @RequestParam Integer reportType) {
        if (StringUtils.isEmpty(templateGroupID)) {
            return Collections.emptyList();
        }

        try {
            return templateService.get(templateGroupID, reportType);
        } catch (Exception e) {
            logger.error("GetCellConfigList", e);
        }
        return Collections.emptyList();
    }
}
