package pwc.taxtech.atms.controller;

import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.dto.TemplateGroupDto;
import pwc.taxtech.atms.service.TemplateGroupService;

import java.util.List;

@RestController
@RequestMapping("/api/v1/templateGroup/")
public class TemplateGroupController {
    private static final Logger logger = LoggerFactory.getLogger(TemplateGroupController.class);

    @Autowired
    TemplateGroupService templateGroupService;

    @ApiOperation(value = "获取所有的模板分组")
    @RequestMapping(value = "getall", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody
    List<TemplateGroupDto> Get() {
        logger.debug("TemplateGroupController Get");
        return templateGroupService.Get();
    }

    @ApiOperation(value = "根据服务类型和行业获取模板分组")
    @RequestMapping(value = "getByIndustry/{serviceTypeID}/{industryID}",method=RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody
    List<TemplateGroupDto> getTemplateGroupByIndustry(@PathVariable int serviceTypeID, @RequestParam Integer taxPayType, @PathVariable String industryID) {
        return templateGroupService.Get(serviceTypeID, taxPayType, industryID);
    }

}
