package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.common.OperateLogType;
import pwc.taxtech.atms.common.OperationModule;
import pwc.taxtech.atms.dto.OperationLogDto;
import pwc.taxtech.atms.dto.PagingResultDto;
import pwc.taxtech.atms.dto.QueryOperateParamDto;
import pwc.taxtech.atms.dto.UpdateLogParams;

public interface OperationLogService {

    void addOperationLog(OperationLogDto operationLogDto);
    
    void addOperationLogList(List<OperationLogDto> operationLogDtoList);

    PagingResultDto<OperationLogDto> getOperationLogList(QueryOperateParamDto queryOperateParamDto);

    /**
     * 修改数据添加日志方法
     * @param updateLogParamsList
     */
    void updateDataAddLog(List<UpdateLogParams> updateLogParamsList);
    
    /**
     * 修改数据添加日志方法
     * @param updateLogParams
     */
    void updateDataAddLog(UpdateLogParams updateLogParams);
    
    /**
     * 新增数据或删除数据添加日志方法
     * @param paramList
     */
    void addOrDeleteDataAddLog(List<UpdateLogParams> updateLogParamsList);
    
    /**
     * 新增数据或删除数据添加日志方法
     * @param updateLogParamsList
     */
    void addOrDeleteDataAddLog(UpdateLogParams updateLogParams);
    
    void AddDataAddLog(Object newObj, OperationModule operationModule, String userName, String operationDesc, String operationContent, String OperationObject, OperateLogType logType);
    
    void UpdateDataAddLog(Object originalObj,Object updateObj,OperationModule operationModule,String userName,String comment,String operationObject,String operationContent,OperateLogType logType);
    
    void DeleteDataAddLog(Object deleteObj, OperationModule operationModule, String userName, String comment, String operationContent, String OperationObject, OperateLogType logType);
}
