package pwc.taxtech.atms.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import pwc.taxtech.atms.common.AtmsApiSettings;
import pwc.taxtech.atms.common.AuthUserHelper;
import pwc.taxtech.atms.dao.*;
import pwc.taxtech.atms.service.OperationLogService;

public class AbstractService {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());
    
    @Autowired
    protected AuthUserHelper authUserHelper;
    @Autowired
    protected AtmsApiSettings atmsApiSettings;
    @Autowired
    protected OperationLogService operationLogService;

    @Autowired
    protected AreaMapper areaMapper;
    @Autowired
    protected AreaRegionMapper areaRegionMapper;
    @Autowired
    protected BusinessUnitMapper businessUnitMapper;
    @Autowired
    protected CustomerMapper customerMapper;
    @Autowired
    protected EnterpriseAccountMapper enterpriseAccountMapper;
    @Autowired
    protected EnterpriseAccountSetMapper enterpriseAccountSetMapper;
    @Autowired
    protected EnterpriseAccountSetOrgMapper enterpriseAccountSetOrgMapper;
    @Autowired
    protected AccountMappingMapper accountMappingMapper;
    @Autowired
    protected AccountMapper accountMapper;
    @Autowired
    protected MailQueueMapper mailQueueMapper;
    @Autowired
    protected MenuMapper menuMapper;
    @Autowired
    protected OperationLogBasicDataMapper operationLogBasicDataMapper;
    @Autowired
    protected OperationLogEnterPriseMapper operationLogEnterpriseMapper;
    @Autowired
    protected OrganizationMapper organizationMapper;
    @Autowired
    protected PermissionMapper permissionMapper;
    @Autowired
    protected RegionMapper regionMapper;
    @Autowired
    protected RolePermissionMapper rolePermissionMapper;
    @Autowired
    protected StandardAccountMapper standardAccountMapper;
    @Autowired
    protected UserMapper userMapper;
    @Autowired
    protected UserRoleMapper userRoleMapper;
    @Autowired
    protected DimensionMapper dimensionMapper;
    @Autowired
    protected DimensionValueMapper dimensionValueMapper;
    @Autowired
    protected StockMapper stockMapper;
    @Autowired
    protected MyStatisticAttributeMapper myStatisticAttributeMapper;
    @Autowired
    protected StatisticAttributeMapper statisticAttributeMapper;
    @Autowired
    protected DimensionValueOrgMapper dimensionValueOrgMapper;
    @Autowired
    protected UserDimensionValueOrgMapper userDimensionValueOrgMapper;
    @Autowired
    protected MyUserMapper myUserMapper;
    @Autowired
    protected ServiceTypeMapper serviceTypeMapper;
    @Autowired
    protected StatisticAttributeDimensionMapper statisticAttributeDimensionMapper;
    @Autowired
    protected RoleCategoryMapper roleCategoryMapper;
    @Autowired
    protected RoleMapper roleMapper;
    @Autowired
    protected UserDimensionValueMapper userDimensionValueMapper;
    @Autowired
    protected UserDimensionValueRoleMapper userDimensionValueRoleMapper;
    @Autowired
    protected UserOrganizationRoleMapper userOrganizationRoleMapper;
    @Autowired
    protected UserOrganizationMapper userOrganizationMapper;
    @Autowired
    protected DictionaryMapper dictionaryMapper;
    @Autowired
    protected OrganizationStructureMapper organizationStructureMapper;
    @Autowired
    protected IndustryMapper industryMapper;
    @Autowired
    protected TaxPayerReportRuleMapper taxPayerReportRuleMapper;
    @Autowired
    protected TaxRuleSettingMapper taxRuleSettingMapper;
    @Autowired
    protected TaxRuleSettingOrganizationMapper taxRuleSettingOrganizationMapper;
    @Autowired
    protected OrganizationServiceTemplateGroupMapper organizationServiceTemplateGroupMapper;
    @Autowired
    protected TemplateGroupMapper templateGroupMapper;
    @Autowired
    protected KeyValueConfigMapper keyValueConfigMapper;
    @Autowired
    protected KeyValueReferenceMapper keyValueReferenceMapper;
    @Autowired
    protected ModelConfigMapper modelConfigMapper;
    @Autowired
    protected CellTemplateMapper cellTemplateMapper;
    @Autowired
    protected CellTemplateConfigMapper cellTemplateConfigMapper;
    @Autowired
    protected TemplateMapper templateMapper;
    @Autowired
    protected  TemplateFormulaMapper templateFormulaMapper;
}
