package pwc.taxtech.atms.service.impl;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dto.CellTemplateConfigDto;
import pwc.taxtech.atms.entitiy.CellTemplate;
import pwc.taxtech.atms.entitiy.CellTemplateConfig;
import pwc.taxtech.atms.entitiy.CellTemplateExample;
import pwc.taxtech.atms.service.CellTemplateService;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class CellTemplateServiceImpl extends AbstractService implements CellTemplateService {

    @Override
    public List<CellTemplateConfigDto> GetCellConfigList(String templateID) {
        List<CellTemplateConfigDto> result = new ArrayList<>();
        CellTemplateExample example = new CellTemplateExample();
        example.createCriteria().andReportTemplateIDEqualTo(templateID);
        List<CellTemplate> cellTemplateList = cellTemplateMapper.selectByExample(example);
        List<CellTemplateConfig> configList = cellTemplateConfigMapper.getCellTemplateConfigByTemplateID(templateID);
        if (cellTemplateList.isEmpty()) {
            return result;
        }

        for (CellTemplate x : cellTemplateList) {
            result.add(GetConfigDto(x, configList.stream().filter(a -> a.getCellTemplateID().equalsIgnoreCase(x.getID())).collect(Collectors.toList())));
        }
        return result;
    }

    private CellTemplateConfigDto GetConfigDto(CellTemplate cellTemplate, List<CellTemplateConfig> configList) {
        CellTemplateConfigDto cellTemplateConfigDto = CellConfigTranslater.GetConfigDto(cellTemplate, configList);
        cellTemplateConfigDto.setCellTemplateID(cellTemplate.getID());
        cellTemplateConfigDto.setTemplateID(cellTemplate.getReportTemplateID());
        cellTemplateConfigDto.setRowIndex(cellTemplate.getRowIndex());
        cellTemplateConfigDto.setRowName(cellTemplate.getRowName());
        cellTemplateConfigDto.setColumnIndex(cellTemplate.getColumnIndex());
        cellTemplateConfigDto.setColumnName(cellTemplate.getColumnName());
        cellTemplateConfigDto.setDataType(cellTemplate.getDataType());
        cellTemplateConfigDto.setIsReadOnly(cellTemplate.getIsReadOnly());
        cellTemplateConfigDto.setFormulaDescription(cellTemplate.getComment());
        return cellTemplateConfigDto;
    }
}
