package pwc.taxtech.atms.service.impl;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.TemplateDto;
import pwc.taxtech.atms.entitiy.Template;
import pwc.taxtech.atms.entitiy.TemplateExample;
import pwc.taxtech.atms.service.TemplateService;

import java.util.ArrayList;
import java.util.List;

@Service
public class TemplateServiceImpl extends AbstractService implements TemplateService {

    @Override
    public List<TemplateDto> get(String templateGroupID, Integer reportType) {

        TemplateExample example = new TemplateExample();

        TemplateExample.Criteria criteria = example.createCriteria().andTemplateGroupIDEqualTo(templateGroupID);

        if (reportType != null) {
            criteria.andReportTypeEqualTo(reportType.intValue());
        }

        example.setOrderByClause("OrderIndex asc");

        List<Template> templates = templateMapper.selectByExample(example);
        List<TemplateDto> templateDtos = new ArrayList<>();
        for (Template template : templates) {
            TemplateDto dto = new TemplateDto();
            CommonUtils.copyProperties(template, dto);
            templateDtos.add(dto);
        }
        return templateDtos;
    }
}
