/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AdminAppNavController', ['$scope', '$rootScope', '$log', 'loginContext', 'enums', '$state',
function ($scope, $rootScope, $log, loginContext, enums, $state) {
    'use strict';
    $log.debug('AdminAppNavController.ctor()...');

    $scope.companyName = loginContext.projectCustomerName;

    $scope.toggleMenu = function () {
        $rootScope.$broadcast(enums.adminEvent.layoutChanged);
    };

    $scope.gotoAdminHomePage = function ($event) {
        var element = $event.target;
        if (element.hasClass('sidebar-toggler')) {
            return;
        } else {
            $state.go('adminHomePage');
        }
    };
}
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('adminAppNav', ['$log',
    function ($log) {
        'use strict';

        $log.debug('adminAppNav.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/admin-app-nav/admin-app-nav.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AdminAppNavController'
        };
    }
]);
frameworkModule.
controller('AppDocumentTreeViewController', ['$scope', '$rootScope', '$attrs', 'documentHierarchyService',
    function ($scope, $rootScope, $attrs, documentHierarchyService) {

        $scope.enableSelect = $attrs.enableSelect;
        $scope.isCollapse = $attrs.isCollapse || false;
        documentHierarchyService.getDocumentHierarchy($attrs.documentType).success(function (documentHierarchy) {
            $scope.documentHierarchy = documentHierarchy;
            $scope.$emit('to-parent', $scope.documentHierarchy);
        });

        documentHierarchyService.getDocumentList($attrs.documentType).success(function (documentList) {
            $rootScope.documentList = documentList; //uses in material-list
        });


        $scope.selectDocument = function (document, parent, clickwhere) {
            $scope.documentClick({ document: document, parent: parent, clickwhere: clickwhere });
        }
    }
]);
// appDocumentTreeView
// Document tree view
frameworkModule.directive('appDocumentTreeView', ['$log',
    function ($log) {
        'use strict';

        $log.debug('treeView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-document-tree-view/app-document-tree-view.html' + '?_=' + Math.random(),
            replace: true,
            scope: { documentClick: '&'},
            //"@" binding is for passing strings. These strings support {{}} expressions for interpolated values.
            //"=" binding is for two-way model binding. The model in parent scope is linked to the model in the directive's isolated scope.
            //"&" binding is for passing a method into your directive's scope so that it can be called within your directive.
            controller: 'AppDocumentTreeViewController',
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppFilterHeaderController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppFilterHeaderController.ctor()...');
         
        $scope.scrollTop= function(){
            $('html,body').animate({scrollTop: '0px'}, 800);
        }
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appFilterHeader', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appFilterHeader.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-filter-header/app-filter-header.html' + '?_=' + Math.random(),
            replace: true,
            transclude: true,
            scope: {},
            controller: 'AppFilterHeaderController',
            link: function (scope, elm, attrs)
            {
                scope.version = attrs.version;
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppFooterController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppFooterController.ctor()...');
         
        $scope.scrollTop= function(){
            $('html,body').animate({scrollTop: '0px'}, 800);
        }
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appFooter', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appFooter.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-footer/app-footer.html' + '?_=' + Math.random(),
            replace: true,
            transclude: true,
            scope: {},
            controller: 'AppFooterController',
            link: function (scope, elm, attrs)
            {
                scope.version = attrs.version;
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppMessageBoxController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppNavController.ctor()...');          

        var mlist = [];
        $scope.size = 0;

        var addMessage = function (Title, Message, Content, CssClass) {
            mlist.push({ message: Message , title: Title ,content: Content , cssClass: CssClass });
            $scope.messageList = mlist;
            $scope.size = mlist.length;
        };

        

        // Just test code

        (function initialize() {
            

            // Reference the auto-generated proxy for the hub.
            var chat = $.connection.messageBoxHub;
            // Create a function that the hub can call back to display messages.

            chat.client.addNewMessageToPage = function (title, message, cssClass) {

                //Add the message to the page.
                var content = message;

                if(message.length > 20){
                    message = message.substring(0, 19) + '...';
                    cssClass += ' cursorpointer';
                }

                $('.cursorpointer').popover({ placement: "right", container: 'body' });

                addMessage(title, message, content, cssClass);
                $scope.$apply();
            };

            $.connection.hub.start().done(function () {              
                // Call the Send method on the hub.
                chat.server.send('hello', 'test Info', 'alert-info');
            });


           

        })();
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appMessageBox', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appMessageBox.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-message-box/app-message-box.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppMessageBoxController'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppModalController', ['$scope', '$log', '$rootScope', '$translate', '$timeout', 'commonWebService', 'loginContext', 'dashboardService', '$interval',
    function ($scope, $log, $rootScope, $translate, $timeout, commonWebService, loginContext, dashboardService, $interval) {
        'use strict';
        $log.debug('AppModalController.ctor()...');

        $scope.init = function () {
            $scope.verifyIsSame = true;
            $scope.oldNewIsSame = false;
            $scope.isSubmited = false;
            $scope.operationStatus = 0;
            $scope.operationFailInfo = "";

            $scope.oldpassword = '';
            $scope.newpassword = '';
            $scope.newpassword_verify = '';

            $scope.disableUpdate = false;
        };

        $scope.init();

        $scope.changePassword = function () {
            var num = 0;
            var number = 0;
            var letter = 0;
            var bigLetter = 0;
            var chars = 0;

            $scope.isSubmited = true;

            if ($scope.form.$invalid) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('FollowTips');

                return;
            }

            if ($scope.oldpassword === '' || $scope.newpassword === '' || $scope.newpassword_verify === '') {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('AnyPasswordCanNotEmpty');
                return;
            }

            if ($scope.newpassword === $scope.oldpassword) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('PasswordNotChanged');

                return;
            }

            if ($scope.newpassword !== $scope.newpassword_verify) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('ConfirmTheSameInfo');

                return;
            }

            if ($scope.newpassword !== '') {
                if ($scope.newpassword.length < 6) {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = '密码长度必须大于等于6位！';
                    return;
                }
                var reg = new RegExp('^(?![0-9]+$)(?![a-zA-Z]+$)[a-zA-Z0-9]{6,20}');
                if (!reg.test($scope.newpassword)) {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = '密码格式不正确，必须为数字和字母组合！';
                    return;
                }
            }

            $scope.disableUpdate = true;
            var passwordList = { oldPassword: $scope.oldpassword, newPassword: $scope.newpassword };
            commonWebService.changePassword(passwordList).success(function (returnData) {
                if (returnData.result) {
                    $scope.operationStatus = 1;
                    $timeout(function () {
                        $("#changePasswordModal").modal("hide");
                    }, 3000);
                }
                else {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = $translate.instant('Msg' + returnData.resultMsg);
                    $scope.disableUpdate = false;
                }
            });

            //Hide Error Message
            $scope.operationStatus = 0;

        };

        $rootScope.$on('event:showChangePasswordModal', function (e, d) {
            $log.debug("event:showChangePasswordModal from:" + d);

            $("#changePasswordModal").modal("show");
        });

        $rootScope.$on('event:comfirmRemove', function (e, d) {
            $log.debug("event:comfirmRemove id:" + d);

            $("#comfirmRemove").data('id', d);

            $("#comfirmRemove").modal("show");
        });

        $rootScope.$on('event:addChart', function (e, d) {
            $log.debug("event:addChart id:" + d);
            $("#addChart").modal("show");
        });

        $scope.comfirmClick = function () {
            var id = $("#comfirmRemove").data('id');
            $scope.$emit('event:comfirmRemoveResult', id);
        };

        //the success callback of getSystemChartList from dashbaord service at ln 101
        var renderTreeMenu = function (systemchartDic) {
            if (typeof (systemchartDic) === "undefined") {
                return;
            }
            var systemchartList = [];
            for (var key in systemchartDic) {
                if (systemchartDic.haOwnProperty(key)) {
                    for (var val in systemchartDic[key]) {
                        if (systemchartDic[key].haOwnProperty(val)) {
                            var chartDto = systemchartDic[key][val];
                            if (!angular.isFunction(chartDto)) {
                                systemchartList.push(chartDto);
                            }
                        }
                    }
                }
            };

            $scope.systemchartDic = systemchartDic;
            $scope.systemchartList4filter = systemchartList;
            $scope.systemchartList = systemchartList;

            $(document).on('click', '.tree-toggle', function () {
                $(this).parent().children('ul.tree').toggle(200);
            });

            $scope.chartName = "自定义仪表盘";
            $scope.chartDescription = "你可以添加新图表，通过拖拽来改变图表放置的位置，也可以删除不需要的图表。<br/>你可以在添加图表功能中选择数据源，系统会为你添加所选择图表在你的仪表盘中。<br/>你可以在编辑图表功能中修改分析维度以及图表样式。";
            $scope.imgUrl = "../../../app-resources/images/addchart/u6.png";
            $scope.systemchartId = "000000";
            $scope.showAddButton = false;
        };

        $scope.initSystemChart = function () {
            $log.debug('AppModalController.initSystemChart()...');
            dashboardService.getSystemChartList().success(renderTreeMenu);
        };

        $scope.showDetail = function (item) {
            if ($scope.noClick) {
                return false;
            }
            $scope.chartName = item.systemChartName;
            $scope.chartDescription = item.description;
            $scope.imgUrl = item.imgUrl;
            $scope.systemchartId = item.systemChartID;
            $scope.showAddButton = true;
        };

        var getUserchartId = function (data) {
            $log.debug('user chart id:' + data);
            $scope.$emit('event:addUserChart', data);
        }

        $scope.confirmAdd = function () {
            dashboardService.addUserChart($scope.systemchartId).success(getUserchartId);
        };


        $scope.showStyle = { display: 'block' };
        $scope.hideStyle = { display: 'none' };

        (function initialize() {
            $log.debug('AppModalController.initialize()...');

            $("#changePasswordModal").on('show.bs.modal', function () {
                $log.debug('The modal is about to be shown.');

                $scope.init();
            });

            //$scope.initSystemChart();

            $('#filter').bind('focus', function () {
                $(this).val('');/*清除数据*/
                var time = $interval(function () {
                    var filter_str = $('#filter').val();

                    var filterArray = [];
                    angular.forEach($scope.systemchartList4filter, function (item) {
                        if (item.systemChartName.indexOf(filter_str) >= 0) {
                            filterArray.push(item);
                        }
                    });

                    $scope.noClick = false;
                    if (filterArray.length == 0) {
                        filterArray.push({ "systemChartName": "NoSearchContent" });
                        $scope.noClick = true;
                    }

                    $scope.queryResult = filterArray;
                    if (filter_str.length > 0) {
                        $scope.showSearch = true;
                    }
                    else {
                        $scope.showSearch = false;
                    }

                }, 300);/*每300毫秒秒执行一次搜索，time是停止本方法的参数*/
                $(this).bind('blur', function () {
                    $interval.cancel(time); /*停止setInterval*/
                });
            });
        })();
    }]);
/// <reference path="app-modal.ctrl.js" />
  
frameworkModule.filter('searchFilter', [function () {

    return function (originalArray, query) {
        if (!angular.isUndefined(originalArray) && !angular.isUndefined(query) && query.length > 0) {
            var tempClients = [];

            angular.forEach(originalArray, function (item) {
                if (item.systemChartName.indexOf(query) >= 0) {
                    tempClients.push(item);
                }
            }); 
            return tempClients;

        } else {
            return originalArray;
        }
    };
}]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appModal', ['$log',
    function ($log)
    {
        'use strict';

        $log.debug('appModal.ctor()...');

        return {
            restrict: 'E',
            require: "appModal",
            templateUrl: '/app/framework/app-modal/app-modal.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                passwordVerify: '='
            },
            controller: 'AppModalController'            
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavBarController', ['$scope', '$log', '$cookies', '$filter', 'loginContext',
function ($scope, $log, $cookies, $filter, loginContext)
{
    'use strict';

    var shownKey = 'shownChangePasswordOf' + loginContext.passwordHash;

    $log.debug('AppNavController.ctor()...');

    $scope.username = loginContext.userName;
    $scope.isExternalUser = loginContext.isExternalUser;

    $scope.showChangePassword = function ()
    {
        $scope.$emit('event:showChangePasswordModal', 'click');
    }

    var todayIsShowed = $cookies.get(shownKey);

    if (loginContext.needChangePassword & !todayIsShowed)
    {
        $scope.$emit('event:showChangePasswordModal', 'auto');


        $cookies.put(shownKey, true);
    }
}
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNavBar', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavBar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-bar/app-nav-bar.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavBarController'
        };
    }
]);
frameworkModule.controller('AppNavContainer', ['$scope', '$log', '$state',
    function ($scope, $log, $state) {
        'use strict';
        $log.debug('AppNavContainer.ctor()...');

        (function initialize() {
            $log.debug('AppNavContainer.initialize()...');

            $scope.$state = $state;
        }());
    }]);
frameworkModule.directive('appNavContainer', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavContainer.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-container/app-nav-container.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavContainer'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavTabController', ['$scope', '$rootScope', '$log', 'enums', 'appTabManager', 'appRoute', '$timeout', 
function ($scope, $rootScope, $log, enums, appTabManager, appRoute, $timeout)
{
        'use strict';
        $log.debug('AppNavTabController.ctor()...');

        var triggeredbyUser = false;
        // select the specified tab from UI or code
        var selectTab = function (tab) {
            $log.debug('AppNavTabController.selectTab(): ' + JSON.stringify({
                tabId: tab.tabId,
                tabName: tab.tabName
            }));

            if ($scope.selectedTab !== tab) {
                appRoute.navigateFromTab(tab, triggeredbyUser);
                triggeredbyUser = false
                $scope.selectedTab = tab;
                appTabManager.selectOpenedTab(tab);
            }           
        };

        // click the specified tab from UI
        var clickTab = function (tab) {
            $log.debug('AppNavTabController.clickTab(): ' + JSON.stringify({
                tabId: tab.tabId,
                tabName: tab.tabName
            }));

            triggeredbyUser = true;

           
        };

        var navigate = function (tabType, eventData) {
            $timeout(function () {
                appRoute.navigate(tabType, eventData);
            }, 0);
        };

        (function initialize() {

            $log.debug('AppNavTabController.initialize()...');

            // properties
            $scope.selectedTab = null;
            $scope.tabs = appTabManager.tabs;

            // methods
            $scope.selectTab = selectTab;
            $scope.clickTab = clickTab;
            $scope.closeTab = function (index) {
                $timeout(function () {
                    appTabManager.closeTabByIndex(index);

                    appRoute.navigateFromTab($scope.tabs[0], triggeredbyUser);
                    triggeredbyUser = false
                    $scope.selectedTab = $scope.tabs[0];
                    appTabManager.selectOpenedTab($scope.tabs[0]);
                }, 0);
            };
            
            // register events
            $rootScope.$on('event:editChart', function (e, d)
            {
                navigate(enums.tabType.chartEdit,
                new appRoute.chartSettingEventData({
                    needActivate: true,
                    chartId: d
                }));
                $scope.selectedTab = null;
            });

            // register events
            $rootScope.$on('event:closeCurrentTab', function ()
            {
                appTabManager.closeCurrentTab();

                appRoute.navigateFromTab($scope.tabs[0], triggeredbyUser);
                triggeredbyUser = false
                $scope.selectedTab = $scope.tabs[0];
                appTabManager.selectOpenedTab($scope.tabs[0]);
            });

            // always load worklist as primary tab at the very beginning

            
            navigate(enums.tabType.dashboard, 
                new appRoute.comonEventData({
                    needActivate: true
                }));
            

            // register events
            $scope.$on('$stateChangeStart',
                function (event, toState, toParams)
                {
                    // transitionTo() promise will be rejected with 
                    // a 'transition prevented' error
                   
                    if (toState == null) {
                        return;
                    }

                    var url = toState.url;

                    var paramList = Object.keys(toParams);

                    _.forEach(paramList, function (item)
                    {
                        url = url.replace("{" + item + "}", toParams[item]);
                    });
                    
                    if (typeof (toState.name) !== 'undefined')
                    {
                       

                        $log.debug("state name:" + toState.name);

                        navigate(enums.tabType.commonUrl,
                        new appRoute.comonEventData({
                            needActivate: true,
                            stateName:toState.name,
                            url: url,
                            param: toParams.param
                        }));
                    }
                });

        }());
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNavTab', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavBar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-tab/app-nav-tab.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavTabController'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavController', ['$rootScope', '$scope', '$log', '$state' ,'loginContext', 'application', 'userService', '$translate', 'vatSessionService', '$interval', 'workflowService',
    function ($rootScope, $scope, $log, $state ,loginContext, application, userService, $translate, vatSessionService, $interval, workflowService) {
        'use strict';
        $log.debug('AppNavController.ctor()...');

        $scope.companyName = loginContext.projectCustomerName;
        $scope.loginUserName = loginContext.userName;
        $scope.tpUrl = loginContext.tpUrl;
        $scope.hasUnreadMsg = true;
        $scope.msgNum = 0;
        $scope.showSubMenu = true;
        $scope.linkAdmin = false;
        $scope.specialUser = $scope.loginUserName.toLowerCase();

        $scope.hasQuerySummaryDashboardCode = false;

        var interval = $interval(function () {
            var data = vatSessionService.userPermission;

            if (data.isAdmin == undefined) return;

            if (data.isAdmin || (data.navigationUrlList && data.navigationUrlList.length > 0)) {
                $scope.linkAdmin = true;
            }
            $interval.cancel(interval);

            $scope.hasQuerySummaryDashboardCode = window.PWC.isHavePermission(constant.vatPermission.dataAnalysis.dashboard.querySummaryDashboardCode, data);
        }, 500);

        //userService.getUserPermission(loginContext.userName).success(function (data) {
        //    if (data) {
        //        if (data.isAdmin || (data.navigationUrlList && data.navigationUrlList.length > 0)) {
        //            $rootScope.linkAdmin = true;
        //        }

        //        $scope.hasQuerySummaryDashboardCode = window.PWC.isHavePermission(constant.vatPermission.dashboard.querySummaryDashboardCode, data)
        //    }
        //});
        $rootScope.$on('notification-read', function () {
            $scope.msgNum--;
        });
        
       var getNotificationInfo = function () {
            $scope.notificationCriteriaX = {
                isFirstTimeLoading: false,
                filterType: "MAIN",
                serviceType: 2,
                mainFilter: "UNREAD",
                singleNode: null,
                singleTask: null,
                multipleNode: null,
                multipleTask: null,
                multipleStatus: null,
                multipleDueDate: null,
                multiplePriority: null,
                multipleType: null,
                searchKeyword: ""
            };

            workflowService.getPushNotifications($scope.notificationCriteriaX).success(function (notifications) {
                if (notifications != null && notifications.notificationList != null)
                    $scope.msgNum = notifications.notificationList.length;
            });
        };

        $scope.setDashboardFlag = function () {
            vatSessionService.urlFromAnalyze = false;
            return true;
        };

        $scope.toggleSubMenu = function (showsub) {
            $scope.showSubMenu = !$scope.showSubMenu;
            //$scope.$emit(application.events.showSubMenu, {direction:'up', show:$scope.showSubMenu});
        };

        $scope.showChangePassword = function () {
            $("#changePasswordModal").modal('show');
            $('.user-menu').css('display', 'none');
        }
        $scope.toggleUserMenu = function (event) {
            if (event.target.parentElement.className === 'user-info' || event.target.parentElement.className === 'ng-binding') {
                $('.user-menu').toggle();
            }
            event.stopPropagation();
        };

        var initSubHeader = function () {
            var enterSubHeader = false;
            $('[hover-show]').hover(function () {
                var className = $(this).attr('hover-show');
                $('.nav-sub-container').hide();
                $('.nav-sub-container.' + className).show();
            }, function () {
                setTimeout(function () { //等待 nav-sub-container hover 设置上对应的值
                    if (enterSubHeader) {
                        var className = $(this).attr('hover-show');
                        $('.nav-sub-container.' + className).hide();
                    }
                }, 200);
            });

            $('.nav-sub-container').hover(function () {
                enterSubHeader = true;
            }, function () {
                enterSubHeader = false;
                $('.nav-sub-container').hide();
            });


            
        };

        //设置 菜单选中状态
        var initState = function(){
            $($('.nav-container .nav-element-left a')[0]).addClass('active');

            $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {                
                $log.debug("$stateChangeStart: toState="+toState.name);

                $('.nav-container .nav-element-left a').removeClass('active');
                $($('.nav-container .nav-element-left a')[getMenuIndex(toState.name)]).addClass('active');
            });
        };

        var getMenuIndex = function(name){
            switch(name){
                case 'GlobalSearch': return 0;
                case 'summary': return 0;
                case 'summaryDashboard': return 3;
                case 'RiskPanel': return 3;
                case 'DataSummary': return 3;
                default: return 2;
            };       
        };

        $scope.search = function(){
            PWC.simulateProgress();
            $state.go('GlobalSearch');
        };


        $(document).click(function (event) {
            $('.user-menu').css('display', 'none');
            event.stopPropagation();
        });

        (function initialize() {
            initSubHeader();
            initState();
            getNotificationInfo();
        })();

    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNav', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNav.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav/app-nav.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavController',
            link: function ($scope, $element, $attr) {
                $element.find('.nav-element-left a').click(function () {
                    $('.nav-element-left a').removeClass('active');
                    $(this).addClass('active');
                });

                $scope.callIframe = function () {

                    $("#dfiframe").contents().find("a:first").click();
                };
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('appSideBarController', ['$scope', '$log', 'menuService', '$window', 'loginContext', 'userService', '$timeout',
    function ($scope, $log, menuService, $window, loginContext, userService, $timeout) {
        'use strict';
        $log.debug('appSideBarController.ctor()...');

        userService.getUserPermission(loginContext.userName).success(function (data) {

            $timeout(function () {
                menuService.getMenusForDisplay(1).success(function (menuData) {

                    $scope.menuData = menuData;
                    if ($scope.specialUser === 'simon') {
                        $scope.menuData[2].subMenus[0].isVisible = false;
                        $scope.menuData[2].subMenus[1].isVisible = false;
                        $scope.menuData[2].subMenus[3].isVisible = false;
                        $scope.menuData[2].subMenus[4].isVisible = false;
                        $scope.menuData[2].subMenus[5].isVisible = false;
                    }
                    $window.location.href = '#/adminHomePage';
                });
            }, 500);
            
        });


        var getMenuItem = function (row, isAdmin, navigationUrlList) {
            if (!row.isVisible) {
                return null;
            }
            if (row.subMenus && row.subMenus.length > 0) {

                // 基础数据维护菜单特殊处理
                if (row.id === constant.BasicDataManageMenuID) {

                    if (!isAdmin) {
                        var subMenus = _.find(row.subMenus, function (num) {
                            return navigationUrlList.indexOf(num.navigationUrl) > -1;
                        });

                        if (subMenus && navigationUrlList.indexOf(row.navigationUrl) === -1) {

                            // 设置基础数据菜单 默认url地址

                            if (navigationUrlList.indexOf(constant.basicDataUrl.businessUnit) > -1) {
                                row.navigationUrl = constant.basicDataUrl.businessUnit;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.regionManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.regionManage;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.enterpriseAccountManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.enterpriseAccountManage;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.customerListManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.customerListManage;
                            }
                        }

                    }

                    row.subMenus = [];

                } else {
                    var menuList = [];
                    row.subMenus.forEach(function (menu) {
                        var temp = getMenuItem(menu, isAdmin, navigationUrlList);
                        if (temp) {
                            menuList.push(temp);
                        }
                    });

                    row.subMenus = menuList;

                }
            }

            // 系统管理就没有地址
            if (!row.navigationUrl && row.subMenus && row.subMenus.length > 0) {
                return row;
            }

            if (isAdmin || (navigationUrlList && navigationUrlList.indexOf(row.navigationUrl) > -1)) {
                return row;
            }
            return null;
        };

        //var apiToken = $cookieStore.get("AtmsApiToken");
        //$scope.loginUser = apiToken.user_name;

        $scope.loginUser = loginContext.userName;
        $scope.specialUser = $scope.loginUser.toLowerCase();

        $scope.logout = function () {
            $window.location.href = '/Account/Logout';
        };

        $scope.convertTo2BitNumber = function (number) {
            var str = "" + number;
            var pad = "00";
            return pad.substring(0, pad.length - str.length) + str;
        };

        (function initialize() {
            $log.debug('appSideBarController.initialize()...');

        })();
    }
]);

// appNavBar
// navigation bar for application
frameworkModule.directive('appSideBar', ['$log',
    function ($log) {
        'use strict';

        $log.debug('sidebar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-side-bar/app-side-bar.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'appSideBarController',
            link: function (scope, element, attr) {

                scope.isMenuClosed = false;
                var superiorMenuActiveClass = 'superior-menu-active';
                //Top Toggler
                var handleSidebarToggler = function () {
                    var body = $('body');

                    // handle sidebar show/hide
                    body.on('click', '.sidebar-toggler', function () {

                        var sidebarMenuSubs = $('#sidebar .nav-second-level, #sidebar .nav-third-level');
                        var sidebarPageClass = 'page-sidebar-minified';
                        //collapse("toggle")
                        $("#sidebar-area .dropdown-collapse").parent("li").children("ul").css('height', '');

                        $(".sidebar-search", $('.page-sidebar')).removeClass("open");
                        if (body.hasClass("sidebar-closed")) {
                            body.removeClass("sidebar-closed");
                            scope.isMenuClosed = false;

                            //代码意图:控制右侧 page-wrapper 宽度以适应菜单栏的变化
                            $("div.admin-wrapper > div.page-wrapper").removeClass(sidebarPageClass);

                            sidebarMenuSubs.addClass('collapse');

                            if ($.cookie) {
                                $.cookie('sidebar-closed', '0');
                            }

                        } else {
                            body.addClass("sidebar-closed");
                            scope.isMenuClosed = true;
                            $("div.admin-wrapper > div.page-wrapper").addClass(sidebarPageClass);

                            if ($.cookie) {
                                $.cookie('sidebar-closed', '1');
                            }
                        }
                        $(window).trigger('resize');
                    });
                };

                //IE Checker
                var isIE = function () {
                    var undef,
                        v = 3,
                        div = document.createElement("div"),
                        all = div.getElementsByTagName("i");
                    while (
                        div.innerHTML = "<!--[if gt IE " + (++v) + "]><i></i><![endif]-->",
                        all[0]
                    ) {
                        return v > 4 ? v : undef;
                    }
                };

                //side menu toggle (init)
                if (isIE() <= 9) {
                    $('#sidebar').find("li.active").has("ul").children("ul").collapse("show");
                    $('#sidebar').find("li").not(".active").has("ul").children("ul").collapse("hide");
                } else {
                    $('#sidebar').find("li.active").has("ul").children("ul").addClass("collapse in");
                    $('#sidebar').find("li").not(".active").has("ul").children("ul").addClass("collapse");
                }

                //side menu toggle (setting)
                $("body").on("click", "#sidebar-area .dropdown-collapse,#sidebar-area a", function () {
                    var currentClass = $(this).attr('class');
                    var len = $(this).siblings('ul').children('li').length;
                    $("#sidebar-area a").removeClass("active");

                    if (currentClass.indexOf('active') >= 0) {
                        $(this).removeClass('active');
                    } else {
                        $(this).addClass('active');
                    }
                    if (len > 0) {
                        $(this).removeClass('active');
                    }

                    $(this).parent("li").children("ul").collapse("toggle");
                    $(this).children(".fa.arrow").toggleClass('active-arrow');
                });

                $("body").on({
                    click: function () {
                        $(this).children(".logout").children("div").toggle();
                    }
                }, ".profile-name");

                handleSidebarToggler();

                var width = (window.innerWidth > 0) ? window.innerWidth : screen.width;

                if ($.cookie && $.cookie('sidebar-closed') === '1' && !$('body').hasClass("sidebar-closed") && width >= 768) {
                    $('body').addClass("sidebar-closed");
                }

                var url = window.location;
                var element = $('ul.nav a').filter(function () {
                    return this.href === url;
                }).addClass('active').parent().parent().addClass('in').parent();
                if (element.is('li')) {
                    element.addClass('active');
                }

                scope.showChangePassword = function () {
                    $("#changePasswordModal").modal('show');
                }
            }
        };
    }
]);
/// <reference path="../app.js" />
/// <reference path="../../Scripts/underscore.js" />

// Responsible for application route from tab and menu
frameworkModule.factory('appRoute', ['$log', 'enums', '$window', '$location', 'appTabManager', '$route', 
    function ($log, enums, $window, $location, appTabManager, $route) {
        'use strict';
        $log.debug('appRoute.ctor()...');

        var hasValue = function (value) {
            return !_.isUndefined(value) && !_.isNull(value) && (value !== '');
        };

        //
        // constructors of event data
        //
        var comonEventData = function (eventData)
        {
            this.needActivate = typeof (eventData) === "undefined" ? true : eventData.needActivate;
            if (eventData != null) {
                this.param = eventData.param || null;
                this.url = eventData.url || null;
                this.stateName = eventData.stateName || null;
            }
           
        };

        var chartSettingEventData = function (eventData)
        {
            this.needActivate = typeof (eventData) === "undefined" ? true : eventData.needActivate;
            if (eventData != null) {
                this.param = eventData.param || null;
                this.url = eventData.url || null;
                this.chartId = eventData.chartId || null;
            }
        };

        var setLocationPathToRouteUrl = function (routeUrl, isNew) {
            if (!hasValue(isNew)) {
                // when navigate from tab we need update the path
                $location.path(routeUrl).search('isNew', null);
            } else {
                // when navigate from tab we need update the path
                $location.path(routeUrl).search('isNew', isNew);
            }

            $log.debug('$locatoin.path: ' + $location.path());
        };


        /// <summary>
        /// contains tabType and eventData information for current route of the navigate is called each time
        /// you can pass param by eventData for route and check appRoute.current.eventData.Param
        /// </summary>
        var currentRoute = {
            // Indicate whether current route is internal navigation or navigation from UI.
            isInternal: false,
            tabType: null,
            eventData: null,
            // set the data for internal navigation
            set: function (tabType, eventData) {
                currentRoute.isInternal = true;
                currentRoute.tabType = tabType;
                currentRoute.eventData = eventData;
            },
            // reset the data for navigation from UI
            reset: function () {
                currentRoute.isInternal = false;
                currentRoute.tabType = null;
                currentRoute.eventData = null;
            }
        };

        var navigateFromTab = function (tab, triggeredbyUser) {
            /// <summary>
            /// navigate from specified tab, this method should only be called when tab clicked on UI
            /// </summary>
            /// <param name="tab">the clicked tab</param>

            $log.debug('appRoute.navigateFromTab(): ' + (tab ? JSON.stringify(tab.tabName) : 'null'));

            if (!tab) {
                return;
            }

            if (triggeredbyUser) {
                currentRoute.reset();
            }

            // when navigate from tab we need update the path
            setLocationPathToRouteUrl(tab.url, tab.isNew);


        };

        // add new tab or active the tab if the tab is already opened
        var loadTab = function (tabType, eventData, onTabLoaded) {
            if (tabType === enums.tabType.main) {
                appTabManager.loadMainTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.dashboard)
            {
                appTabManager.loadDashboardTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.chartEdit)
            {
                appTabManager.loadChartEditTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.commonUrl)
            {
                appTabManager.loadCommonUrlTab(eventData, onTabLoaded);
            }
            else
            {
                $log.error(tabType + ' is not supported!');
            }
        };
        var routeEvents = {
            navigated: 'app-route-navigated'
        };
        var navigate = function (tabType, eventData) {
            currentRoute.set(tabType, eventData);

            loadTab(tabType, eventData, function (tab, eventData) {
                $log.debug('appRoute.onTabLoaded(): ' + tab.tabName);

                // set active for current tab
                tab.active = eventData.needActivate;

                if (tab.url !== '/') {
                    setLocationPathToRouteUrl(tab.url, tab.isNew);

                    if ($route.current) {
                        $route.current.scope.$broadcast(routeEvents.navigated);
                    }
                } else {
                    appTabManager.closeTab(tab.tabId);
                }
            });
        };


      

        (function initialize() {
            $log.debug('appRoute.initialize()...');
        })();

        // public properties and methods of appRoute
        return {
            navigateFromTab: navigateFromTab,
            navigate: navigate,
            comonEventData: comonEventData,
            chartSettingEventData: chartSettingEventData,
            current: currentRoute,
            routeEvents: routeEvents
        };
    }
]);
// appTabManager is responsible for loading or closing tabs 
frameworkModule.factory('appTabManager', ['$log', 'enums', '$filter', 'constants', '$translate', '$rootScope', '$timeout', '$window', '$stickyState', 'risDialog',
    function ($log, enums, $filter, constants, $translate, $rootScope, $timeout, $window, $stickyState, risDialog) {
        'use strict';
        $log.debug('appTabManager.ctor()...');

        var broadcastTabsChangedEvent = function () {
            // use $timeout to wait for the DOM get updated completed!
            $timeout(function () {
                $rootScope.$broadcast('appTabManager:tabsChanged');
            }, 300);
        };

        /// <summary>
        ///  tab collection on application nav bar
        /// </summary>
        var tabs = [];

        var meetTabCeiling = function () {
            if (tabs.length >= constants.tabCeiling) {
                risDialog({
                    id: 'simpleDialog',
                    template:
                      '<div class="row-fluid">' +
                      ' <h4>您打开的窗口过多，这会影响工作效率，请关闭部分窗口。</h4>' +
                      ' <div>' +
                      '   <div class="codebox">' +
                      '   </div>\n' +
                      ' </div>\n' +
                      '</div>',
                    title: '提示',
                    backdrop: true
                });

                return true;
            }
            return false;
        };

        var selectOpenedTab = function (tab) {
            var list = [];
            if (tabs.length > 0) {
                angular.forEach(tabs, function (tabInfo) {
                    tabInfo.active = tabInfo.tabId === tab.tabId;
                });
            }

            return list;
        };

        tabs.insert = function (index, tab) {
            if (meetTabCeiling()) {
                return false;
            }

            tabs.splice(index, 0, tab);
            broadcastTabsChangedEvent();
            selectOpenedTab(tab);
            return true;
        };

        tabs.add = function (tab) {
            if (meetTabCeiling()) {
                return false;
            }

            tabs.push(tab);
            broadcastTabsChangedEvent();
            selectOpenedTab(tab);
            return true;
        };

        tabs.remove = function (index) {
            if (index > 0) {
                tabs.splice(index, 1);
                broadcastTabsChangedEvent();

                return true;
            }
            selectOpenedTab(tabs[0]);
            return false;
        }

    

        //get opened tabs data to save
        var getOpenedTabs = function (userId) {
            var list = [];
            if (tabs.length > 0) {
                angular.forEach(tabs, function (tabInfo, index) {
                    var tab = {};
                    tab.isWorking = tabInfo.active;
                    tab.position = index;
                    tab.tabId = tabInfo.tabId;
                    tab.tabType = tabInfo.tabType;
                    tab.userId = userId;
                    list.push(tab);
                });
            }

            return list;
        };


        // after tab closed, remove the dom element from ui-view
        var resetState = function (tab) {
            if (tab.route) {
                tab.route.tabId = '';
                tab.route.isWorking = false;
                tab.route = null;
            }

            $timeout(function () {
                $stickyState.reset(tab.state);
            }, 0);
        };

        var closeTabByIndex = function (index) {
            if (_.isNumber(index)) {
                var tab = tabs[index];
                tabs.remove(index);

                resetState(tab);

                selectOpenedTab(tabs[0]);
            } else {
                // do nothing
            }
        };

        var closeCurrentTab = function ()
        {
            _.each(tabs, function (item, index)
            {
                if (item.active)
                {
                    tabs.remove(index);
                }
            });

            selectOpenedTab(tabs[0]);
            
        };

        var closeTab = function (tabId) {
            var tab = _.findWhere(tabs, {
                tabId: tabId
            });
            if (tab) {
                var index = tabs.indexOf(tab);
                tabs.remove(index);

                resetState(tab);

                selectOpenedTab(tabs[0]);
            } else {
                // do nothing
            }
        };
 

        //main
        var createMainTab = function () {
            var mainTab = {
                tabType: enums.tabType.main,
                tabId: PWC.newGuid(),
                url: '/main',
                tabName: '主页' // just demo, need do i18n in future
            };

            return mainTab;
        };

        var loadMainTab = function (eventData, onTabLoaded) {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.main
            });

            if (!tabItem)
            {
                tabItem = createMainTab();
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, eventData);
                }
            } else {
                onTabLoaded(tabItem, eventData);
                selectOpenedTab(tabItem);
            }
        };

        //dashboard
        var createDashboardTab = function ()
        {
            var mainTab = {
                tabType: enums.tabType.dashboard,
                tabId: PWC.newGuid(),
                url: '/dashboard/compare',
                tabName: '数据汇总'
            };

            return mainTab;
        };

        var loadDashboardTab = function (eventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.dashboard
            });

            if (!tabItem)
            {
                tabItem = createDashboardTab();
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, eventData);
                }
            }
            else
            {
                onTabLoaded(tabItem, eventData);
                selectOpenedTab(tabItem);
            }
        };

        //dashboard
        var createChartEditTab = function (chartSettingEventData)
        {
            var tabItem = {
                tabType: enums.tabType.chartEdit,
                tabId: PWC.newGuid(),
                chartId: chartSettingEventData.chartId,
                url: '/dashboardsetting/{0}'.format(chartSettingEventData.chartId), 
                tabName: $translate.instant('chartsetting')
            };

            return tabItem;
        };

        var loadChartEditTab = function (chartSettingEventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.chartEdit, chartId: chartSettingEventData.chartId
            });

            if (!tabItem)
            {
                tabItem = createChartEditTab(chartSettingEventData);
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, chartSettingEventData);
                }
            } else
            {
                selectOpenedTab(tabItem);
                onTabLoaded(tabItem, chartSettingEventData);
            }
        };

        //dashboard
        var createCommonUrlTab = function (comonEventData)
        {
            var tabItem = {
                tabType: enums.tabType.commonUrl,
                tabId: PWC.newGuid(),
                url: comonEventData.url.format(comonEventData.param),
                tabName: $translate.instant(comonEventData.stateName)
            };

            return tabItem;
        };

        var loadCommonUrlTab = function (comonEventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                url: comonEventData.url
            });

            if (!tabItem)
            {
                tabItem = createCommonUrlTab(comonEventData);
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, comonEventData);
                }
            }
            else
            {
                selectOpenedTab(tabItem);
            }
        };


        return {
            tabs: tabs,
            getOpenedTabs: getOpenedTabs,
            closeTabByIndex: closeTabByIndex,
            closeTab: closeTab,
            closeCurrentTab: closeCurrentTab,
            loadMainTab: loadMainTab,
            loadDashboardTab: loadDashboardTab,
            loadChartEditTab: loadChartEditTab,
            loadCommonUrlTab: loadCommonUrlTab,
            selectOpenedTab: selectOpenedTab
        };
    }
]);
/// <reference path="../../app.js" />
/// <reference path="../enums.js" />
commonModule.factory('appTabRouteProvider', ['$log', 'enums', 'constants',
    function ($log, enums, constants) {
    'use strict';
    $log.debug('appTabRouteProvider.ctor()...');
    var i;
    var reportDynamicRoutes = [];
    var getTabRouteUrl = function (tab)
    {
        if (tab.tabType === enums.tabType.worklist) {
            tab.state = 'dashboard'
            return '/dashboard/compare';
        } else if (tab.tabType === enums.tabType.registration) {
           
            return '/';
        } else if (tab.tabType === enums.tabType.report) {
            var availableTab = _.find(reportDynamicRoutes, function (route) { return route.tabId === tab.tabId; });
            if (availableTab) {
                return '/{0}/{1}'.format(availableTab.routeViewName, tab.tabId);
            }

            availableTab = _.find(reportDynamicRoutes, function (route) { return route.isWorking === false; });
            if (availableTab) {
                availableTab.tabId = tab.tabId;
                availableTab.isWorking = true;
                tab.state = availableTab.routeState;
                tab.route = availableTab;
                return '/{0}/{1}'.format(availableTab.routeViewName, tab.tabId);
            }

            $log.error('Registration met the ceiling!');
            return '/';
        } else if (tab.tabType === enums.tabType.clientSetting) {
            tab.state = 'progress';
            return '/progress';
        } else if (tab.tabType === enums.tabType.selfServiceSetting) {
            tab.state = 'ris.selfservicesetting'
            return '/selfservicesetting';
        } else {
            $log.error(tab.tabType + ' is not supported!');
            return '/';
        }
    };

    var tabCeiling = constants.tabCeiling - 1;
    var registrationDynamicRoutes = [];
    for (i = 1; i <= tabCeiling; i++) {
        registrationDynamicRoutes.push({
            routeState: 'ris.registration{0}'.format(i),
            routeViewName: 'registration{0}'.format(i),
            isWorking: false,
            tabId: ''
        });
    };

    
    for (i = 1; i <= tabCeiling; i++) {
        reportDynamicRoutes.push({
            routeState: 'ris.report{0}'.format(i),
            routeViewName: 'report{0}'.format(i),
            isWorking: false,
            tabId: ''
        });
    };

    return {
        getTabRouteUrl: getTabRouteUrl,
        registrationDynamicRoutes: registrationDynamicRoutes,
        reportDynamicRoutes: reportDynamicRoutes
    };
}
]);
var RIS = RIS || {};

// This class contains the customized error class.

PWC.ApplicationError = (function () {
    'use strict';

    var applicationError = function () {
        var tmp = Error.prototype.constructor.apply(this, arguments);
        this.message = tmp.message;
        this.name = "PWC.ApplicationError";

        // Generate stack trace, for now Firefox and Chrome support it, but IE not.
        var err = new Error();
        if (err.stack) {
            this.stack = err.stack;
        }

        //we should define how our toString function works as this will be used internally
        //by the browser's stack trace generation function
        this.toString = function () {
            return this.name + ': ' + this.message;
        };

        return this;
    }
    applicationError.prototype = new Error();
    applicationError.prototype.constructor = applicationError;

    return applicationError;
})();

PWC.ServiceError = (function () {
    'use strict';

    var serviceError = function () {
        var tmp = PWC.ApplicationError.prototype.constructor.apply(this, arguments);
        this.message = tmp.message;
        this.name = "PWC.ServiceError";
        return this;
    }
    serviceError.prototype = new PWC.ApplicationError();
    serviceError.prototype.constructor = PWC.ServiceError;

    return serviceError;
})();
var RIS = RIS || {};

/**
 * Loads javascript files or CSS files into the document
 */
PWC.Loader = function () {
    'use strict';

    function loadResource(resourceUrl, resoruceType, callback, element) {
        /// <summary>
        /// Loads the specified resource into the document. Supported are
        /// CSS and javascript files
        /// </summary>
        /// <param name="resourceUrl">The URL of the script or CSS file</param>
        /// <param name="resoruceType">The mime type of the library</param>
        /// <param name="callback">The function to call on successfull load</param>
        /// <param name="element">The document in which the library is to be loaded</param>
        if (!resourceUrl) {
            throw new PWC.ApplicationError('unknow resourceUrl when load resourse.');
        }
        var theElem = element || document;
        // if this library is already loaded just call the function
        if (isResoruceLoaded(resourceUrl, theElem)) {
            if (callback) {
                callback(resourceUrl, resoruceType, false);
            }
            return;
        }

        var isDoc = theElem.nodeType === 9;
        var libElem = createResourceElement(resourceUrl, resoruceType, (isDoc ? theElem : document));
        var hd = isDoc ? theElem.getElementsByTagName("head")[0] : theElem;

        if (libElem && hd) {
            if (resoruceType === "text/javascript" || resoruceType === "text/css") {
                libElem.addEventListener("load", function () {
                    callback(resourceUrl, resoruceType, true);
                }, false);
            } else {
                callback(resourceUrl, resoruceType, true);
            }
            hd.appendChild(libElem);

            var libs = theElem.libraries;
            if (typeof (libs) === "undefined") {
                libs = theElem.libraries = {};
            }
            libs[resourceUrl] = true;
        }// if(libElem...
    }

    function isResoruceLoaded(resourceUrl, element) {
        /// <summary>
        /// Determines if the resource is successfully loaded
        /// in the given document
        /// </summary>
        /// <param name="resourceUrl">The path of the library</param>
        /// <param name="element">The document obejct</param>
        /// <returns type="bool">true if the given library has already been loaded in the document</returns>
        element = element || document;
        var libs = element.libraries;
        if (typeof (libs) === "undefined") {
            return false;
        }
        return libs[resourceUrl] === true;
    }

    function createResourceElement(resourceUrl, resourceType, elementOwner) {
        /// <summary>
        /// Creates a script or a link elementOwner.
        /// </summary>
        /// <param name="resourceUrl">The URL of the script or CSS file</param>
        /// <param name="resourceType">The resourceType of library, currently supported are "text/javascirpt", "text/css"</param>
        /// <param name="elementOwner">The DOM document in which to create the library elementOwner</param>
        /// <returns>the dom elementOwner representing the library</returns>
        var resourceElement = null;
        if (resourceType === "text/javascript") {
            resourceElement = elementOwner.createElement("script");
            resourceElement.setAttribute("resourceType", resourceType);
            if (resourceUrl) {
                resourceElement.setAttribute("src", resourceUrl);
                resourceElement.src = resourceUrl;
            }
        } else if (resourceType === "text/css") {
            resourceElement = elementOwner.createElement("link");
            resourceElement.setAttribute("rel", "stylesheet");
            resourceElement.setAttribute("resourceType", resourceType);
            if (resourceUrl) {
                resourceElement.setAttribute("href", resourceUrl);
                resourceElement.href = resourceUrl;
            }
        }

        if (resourceElement) {
            resourceElement.setAttribute("id", resourceUrl.replace("/", "_", "g"));
        }
        return resourceElement;
    }

    function doCallback(resources, callback, hasNewJsLoaded) {
        try {
            callback(hasNewJsLoaded);
        } catch (err) {
            var s = "";
            for (var k = 0, klen = resources.length; k < klen; k++) {
                s += resources[k].url + "\n";
            }
            $log.debug(err + ": In call-back function while loading:\n\n" + s);
        }
    }

    return {
        loadJs: function (jsUrl, callback, domElement) {
            /// <summary>
            /// Loads a javascript file/resource into the specified domElement
            /// </summary>
            /// <param name="jsUrl">The jsUrl of the script.</param>
            /// <param name="callback">The function to call on successfull load</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            loadResource(jsUrl, "text/javascript", callback, domElement);
        },

        loadCss: function (cssUrl, domElement) {
            /// <summary>
            /// Loads the specified CSS stylesheet
            /// </summary>
            /// <param name="cssUrl">The url of the CSS stylesheet</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            loadResource(cssUrl, "text/css", null, domElement);
        },

        loadResource: function (resourceUrl, resourceType, callback, domElement) {
            /// <summary>
            /// Loads a javascript or CSS into the specified document.
            /// </summary>
            /// <param name="resourceUrl">The URL of the resource</param>
            /// <param name="resourceType">The mimetype of the reource, text/css OR text/javascript</param>
            /// <param name="callback">The function to call after successfull loading of the file</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            return loadResource(resourceUrl, resourceType, callback, domElement);
        },

        load: function (resources, callback, domElement) {
            /// <summary>
            /// Loads an array of resource into the specified dom document and calls
            /// the given function after successfully loading the scripts
            /// </summary>
            /// <param name="resources">The array of script info objects. The objects have
            /// following fields {url:"the url", type:"text/css | text/javacript"}</param>
            /// <param name="callback">The function to call after successfull loading of the file</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            var idx = 0;
            var hasNewJsLoaded = false;
            var loadInternal = function () {
                if (resources.length > 0) {
                    var sInfo = resources[idx];
                    loadResource(sInfo.url, sInfo.type, loadCallback, domElement);
                } else {
                    doCallback(resources, callback);
                }
            };

            var loadCallback = function (resourceUrl, resoruceType, isNewLoaded) {
                if (resoruceType === "text/javascript") {
                    hasNewJsLoaded = hasNewJsLoaded | isNewLoaded;
                }
                ++idx;
                if (idx >= resources.length) {
                    doCallback(resources, callback, hasNewJsLoaded);
                } else {
                    loadInternal();
                }
            };

            loadInternal();
        },

        toString: function () {
            return "PWC.Loader";
        }
    };
}();
webservices.factory('vatSessionService', ['$log', 'localStorageService', function ($log, localStorageService) {
    'use strict';
    $log.debug('vatSessionService.ctor()...');

    var date = new Date();
    var month = date.getMonth();
    var projectyear = date.getFullYear();
    if (month <= 0) {
        month = 1;
    }
    var logUser =
       {
           ID: "66933E7B-DA75-4B2E-B7D6-AB65DCA20D50",
           UserName: "Admin",
       };

    var userPermission = {};

    var queryDto = {
        searchKeyword: '',
        fieldId: '',
        filedName: 'orgName',
        checkedOrgs: {},
    };

    var reset = function () {
        var date = new Date();
        var m = date.getMonth();
        if (m <= 0) {
            m = 1;
        }
        this.month = m;
        setProperty("month", m);
    };
    var cacheObj = {
        month: month,
        userPermission: {},
        project: { year: 2017 },
        projects: [],
        dataChanged: false
    };
    var temp = localStorageService.get('tesla-cache');
    if (temp) {
        cacheObj = temp;
    } else {
        localStorageService.set('tesla-cache', cacheObj);
    }

    var setProperty = function (propertyName, propertyValue) {
        cacheObj[propertyName] = propertyValue
        //$cookieStore.put('tesla-cache', JSON.stringify(apiTokenObj));
        localStorageService.set('tesla-cache', cacheObj);
    }

    var getProperty = function (propertyName) {
        //console.log($cookieStore.get('tesla-cache'));
        return cacheObj[propertyName];
    }

    // 跳转到admin或者outputinvoice management 需要清空所选择的project，不然会影响权限
    var clearSelectProject = function () {
        var tempProject = { year: 2017 };

        setProperty('project', tempProject);
    };

    return {
        month: month,
        year: projectyear,
        project: { year: 2017 },
        projects: [],
        dataChanged: false,
        logUser: logUser,
        reset: reset,
        userPermission: userPermission,
        queryDto: queryDto,
        setProperty: setProperty,
        getProperty: getProperty,
        clearSelectProject: clearSelectProject,
    }
}]);
/// <reference path="../../app.js" />

// apiInterceptor is responsible to handle the aspect of each request and response.
webservices.factory('apiInterceptor', ['$q', 'loginContext', '$log', '$window', '$injector',
    function ($q, loginContext, $log, $window, $injector) {
        'use strict';

        $log.debug('apiInterceptor.ctor()...');

        var apiToken = loginContext.apiToken;
        var tokenType = loginContext.tokenType;
        var webApiHostUrl = loginContext.apiHost + constant.webapi.prefix;
        //for vat api
        var vatWebApiHostUrl = loginContext.vatApiHost + constant.webapi.prefix;

        var redirectToLogOut = loginContext.redirectToLogOutFunction;

        return {
            //token save to services for further usage
            tokenType: tokenType,
            apiToken: apiToken,
            webApiHostUrl: webApiHostUrl,
            //for vat api
            vatWebApiHostUrl: vatWebApiHostUrl,

            // On request success
            request: function (config) {

                // Check if this request is a web api call, we should only update url and header for each web api request.
                // Because angular will use the $http service as well internally, such as ng-include to request a html file from server.
                // Set this config to send request to a different web server will break the functions of angularJS.
                if (config.isWebApiRequest) {
                    config.headers = config.headers || {};
                    config.headers.Authorization = tokenType + ' ' + apiToken;
                    if (config.apiType == 'vat') {
                        config.url = vatWebApiHostUrl + config.url;
                    }
                    else {
                        config.url = webApiHostUrl + config.url;
                    }
                    config.withCredentials = true;

                    // before each api call, try to ensure user account has not been expired
                    // otherwise, force user to login again
                    var $http = $injector.get('$http');
                    $http.get(loginContext.serverUrl + '/Account/CheckLoginStatus?_=' + (new Date).valueOf(), { isBusyRequest: true }).success(function (data) {
                        if (data === false) {
                            redirectToLogOut();
                        }
                    });
                }

                return config;
            },
            // On request failure
            requestError: function (rejection) {
                $log.error(rejection); // Contains the data about the error on the request.

                // Return the promise rejection.
                return $q.reject(rejection);
            },
            // On response success
            response: function (response) {
                if (response.status === 401) {
                    redirectToLogOut();
                }
                return response || $q.when(response);
            },
            // On response failture
            responseError: function (rejection) {
                $log.error(rejection); // Contains the data about the error.

                if (rejection.status === 401) {
                    redirectToLogOut();
                }

                // Return the promise rejection.
                return $q.reject(rejection);
            }
        };
    }])
.factory('requestNotificationInterceptor', ['$q', '$injector', '$log', function ($q, $injector, $log) {
    'use strict';

    $log.debug('busyRequestNotificationInterceptor.ctor()...');

    var busyRequestNotificationHub;
    var busyRequestUrl = null;
    var requestOntheWay = 0;

    function onRequestStarted(config) {
        if (config.isWebApiRequest && config.isBusyRequest) {
            //$log.debug('busyRequestNotificationInterceptor: Start busy request ' + config.url);
            //busyRequestNotificationHub = busyRequestNotificationHub || $injector.get('busyRequestNotificationHub');
            //busyRequestNotificationHub.requestStarted();
            //busyRequestUrl = config.url;
        }

        if (config && typeof (config.ignoreLoadingBar) !== 'undefined' && !config.ignoreLoadingBar) {
            requestOntheWay++;
        }

        if (requestOntheWay > 0) {
            $('#busy-indicator-container').show();
        }
    }

    function onRequestEnded(config) {
        if (busyRequestUrl && config.url === busyRequestUrl) {
            //$log.debug('busyRequestNotificationInterceptor: Finish busy request ' + config.url);
            //busyRequestNotificationHub = busyRequestNotificationHub || $injector.get('busyRequestNotificationHub');
            //busyRequestNotificationHub.requestEnded();
            //busyRequestUrl = null;
        }

        if (config && typeof (config.ignoreLoadingBar) !== 'undefined' && !config.ignoreLoadingBar) {
            requestOntheWay--;
        }

        if (requestOntheWay <= 0) {
            $('#busy-indicator-container').hide();
        }
    }

    return {
        // On request success
        request: function (config) {
            onRequestStarted(config);
            return config;
        },
        // On request failure
        requestError: function (rejection) {
            onRequestEnded(rejection.config);
            return $q.reject(rejection);
        },
        // On response success
        response: function (response) {
            onRequestEnded(response.config);
            return response || $q.when(response);
        },
        // On response failture
        responseError: function (rejection) {
            onRequestEnded(rejection.config);
            return $q.reject(rejection);
        }
    }
}]);

webservices.config(['$httpProvider', function ($httpProvider) {
    $httpProvider.interceptors.push('apiInterceptor');
    $httpProvider.interceptors.push('requestNotificationInterceptor');
}]);

// All web api request should use this service to create its config for request.
webservices.factory('apiConfig', ['$log', 'vatSessionService',
    function ($log, vatSessionService) {

        $log.debug('apiConfig.ctor()...');

        return {
            create: function (config) {
                var cfg = {
                    apiType: 'admin',
                    ignoreLoadingBar: false
                };
                if (config) {
                    cfg = _.extend(cfg, config);
                }

                cfg.isWebApiRequest = true;
                if (config && config.dbName) {
                    cfg.headers = { 'from': config.dbName + '@cn.pwc.com' };
                }
                else {
                    if (vatSessionService.project && vatSessionService.project.dbName) {
                        cfg.headers = { 'from': vatSessionService.project.dbName + '@cn.pwc.com' };
                    }
                }
                return cfg;
            },
            createVat: function (config) {
                var cfg = {
                    apiType: 'vat',
                    ignoreLoadingBar: false
                };
                if (config) {
                    cfg = _.extend(cfg, config);
                }

                cfg.isWebApiRequest = true;
                if (config && config.dbName) {
                    cfg.headers = { 'from': config.dbName + '@cn.pwc.com' };
                }
                else {
                    cfg.headers = { 'from': vatSessionService.project.dbName + '@cn.pwc.com' };
                }
                //$httpProvider.defaults.headers.common['from'] = vatSessionService.project.dbName + '@cn.pwc.com';
                //cfg.headers.from = vatSessionService.project.dbName+'@cn.pwc.com';
                return cfg;
            }
        };
    }]);